<template>
  <authenticated-vue>
    <div class="w-100 bg-white shadow-lg p-5" id="card">
      <header class="text-gray-600 py-3 pb-5 flex justify-between">
        <h3 class="text-xl">จัดการโครงการ</h3>

        <inertia-link
          :href="route('admin.projects.create')"
          class="
            transition
            duration-200
            ease-in-out
            transform
            hover:-translate-y-1
            px-3
            py-1
            bg-gradient-to-r
            from-blue-500
            to-green-300
            rounded-md
            text-white
            shadow-md
            focus:outline-none
          "
        >
          เพิ่มโครงการ
        </inertia-link>
      </header>
      <div id="content">
        <div class="grid grid-cols-1 md:grid-cols-3 lg:grid-cols-5 gap-5 mb-5">
          <el-select
            v-model="budget_year_id"
            filterable
            placeholder="ปีงบประมาณ"
          >
            <el-option
              v-for="item in budget_years"
              :key="item.id"
              :label="item.year"
              :value="item.id"
            >
            </el-option>
          </el-select>
          <input
            type="text"
            class="
              px-3
              py-2
              rounded
              border border-gray-200
              placeholder-gray-300
              col-span-2
            "
            v-model="search"
            placeholder="ค้นหา.."
            ref="focus"
          />
        </div>
        <project-table :tableData="projects" :expandRow="expandRow" />
        <div v-if="project.links.length > 3" class="mt-5">
          <pagination :links="project.links" />
        </div>
      </div>
    </div>
  </authenticated-vue>
</template>

<script>
import AuthenticatedVue from "@/Layouts/Authenticated.vue";
import Pagination from "@/Components/Pagination.vue";
import ProjectTable from "@/Components/Project/ProjectTable.vue";
import Swal from "sweetalert2";
import { reactive, ref, toRefs } from "@vue/reactivity";
import { computed, onMounted, watch } from "@vue/runtime-core";
import { Inertia } from "@inertiajs/inertia";

export const Toast = Swal.mixin({
  toast: true,
  position: "top-end",
  showConfirmButton: false,
  timer: 3000,
  timerProgressBar: true,
  didOpen: (toast) => {
    toast.addEventListener("mouseenter", Swal.stopTimer);
    toast.addEventListener("mouseleave", Swal.resumeTimer);
  },
});

export default {
  props: {
    project: Object,
    budget_years: Array,
  },
  components: { AuthenticatedVue, Pagination, ProjectTable },
  setup(props) {
    const { project } = toRefs(props);
    const budget_year_id = ref(parseInt(route()?.params?.yearsId) || 1);
    const focus = ref(null);

    const search = ref(null);
    const expandRow = ref([]);

    const setExpandRow = (handleTreeData) => {
      if (handleTreeData.length) {
        for (let i of handleTreeData) {
          expandRow.value.push(i.id);
          if (i.children.length) {
            setExpandRow(i.children);
          }
        }
      }
    };

    const _handleTreeData = (treeData, searchValue) => {
      if (!treeData || treeData.length === 0) {
        return [];
      }
      const array = [];
      for (let i = 0; i < treeData.length; i += 1) {
        let match = false;
        for (let pro in treeData[i]) {
          if (typeof treeData[i][pro] == "string") {
            match |= treeData[i][pro].includes(searchValue);
            if (match) break;
          }
        }
        if (
          _handleTreeData(treeData[i].children, searchValue).length > 0 ||
          match
        ) {
          array.push({
            ...treeData[i],
            children: _handleTreeData(treeData[i].children, searchValue),
          });
        }
      }
      return array;
    };
    const projects = computed(() => {
      let searchValue = search.value;
      let treeData = project.value.data;
      if (searchValue) {
        treeData = project.value.data;
        let handleTreeData = _handleTreeData(treeData, searchValue);
        setExpandRow(handleTreeData);
        expandRow.value = expandRow.value.join(",").split(",");
        return handleTreeData;
      }
      return treeData;
    });

    watch([budget_year_id, search], (val) => {
      if (val[0] && !val[1]) {
        Inertia.get(route("admin.projects.index"), { yearsId: val[0] });
      }
    });

    return {
      budget_year_id,
      search,
      projects,
      focus,
      project,
      expandRow
    };
  },
};
</script>

<style>
</style>
